﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Infragistics.Controls.Grids;
using Infragistics.DragDrop;

namespace xamGrid_DragAndDrop_CS
{
    /// <summary>
    /// MainWindow.xaml の相互作用ロジック
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            ObservableCollection<Item> items = new ObservableCollection<Item>();
            items.Add(new Item { ID = 1, Name = "Name1", Note = "Note1" });
            items.Add(new Item { ID = 2, Name = "Name2", Note = "Note2" });
            items.Add(new Item { ID = 3, Name = "Name3", Note = "Note3" });

            this.DataContext = items;
        }

        private void DragSource_DragStart(object sender, DragDropStartEventArgs e)
        {
            CellControl sourceCell = (CellControl)VisualTreeHelper.GetParent(e.DragSource);

            if (sourceCell.Cell.Row.RowType != RowType.DataRow)
                e.Cancel = true;
        }

        private void DragSource_Drop(object sender, DropEventArgs e)
        {
            CellControl sourceCell = (CellControl)VisualTreeHelper.GetParent(e.DragSource);
            CellControl targetCell = (CellControl)VisualTreeHelper.GetParent(e.DropTarget);
            XamGrid grid = targetCell.Cell.Row.ColumnLayout.Grid;
            Row tmpRow;

            if (sourceCell == targetCell)
                return;

            if (targetCell.Cell.Row.RowType != RowType.DataRow)
                return;

            if ((sourceCell.Cell.Column.ColumnLayout == targetCell.Cell.Column.ColumnLayout))
            {
                tmpRow = (Row)sourceCell.Cell.Row;
                tmpRow.Delete();

                grid.Rows.Insert(targetCell.Cell.Row.Index, tmpRow);
            }
        }
    }
    
    public class Item
    {
        public int ID { get; set; }
        public string Name { get; set; }
        public string Note { get; set; }
    }
}
